/***************************************************************************
 *   Copyright (C) 2005 by Mc   *
 *   mc@bglug.it   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifndef CDIALOGMUSICBRAINZFETCH_H
#define CDIALOGMUSICBRAINZFETCH_H

#include "DialogMusicbrainzFetch.h"
#include "qcombobox.h"
#include "qbuttongroup.h"
#include <qstringlist.h>

typedef struct
  {
    QStringList artist;
    QStringList album;
    QStringList title;
    QStringList trackNum;
    QStringList year;
  }
SONG_STRUCT;

class CDialogMusicbrainzFetch: public MusicbrainzFetch
  {
    Q_OBJECT
  public:
    CDialogMusicbrainzFetch(QWidget *parent , const char *name , SONG_STRUCT fetchResults);
    SONG_STRUCT *_fetchResults;
  private:
    void accept();
    void close();
    QStringList removeDups(const QStringList &);
    void syncComboBoxs(int index);

  private slots:
    void albumActivated(const QString &);
    void artistActivated(const QString &);
    void trackNumActivated(const QString &);
    void titleActivated(const QString &);
    void yearActivated(const QString &);
  };

#endif
