/***************************************************************************
 *   Copyright (C) 2005 by Mc   *
 *   mc@bglug.it   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/


#ifndef _KMP3TAG_H_
#define _KMP3TAG_H_

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif


#include <kio/job.h>        //KDE
#include <kmainwindow.h>    //KDE
#include <klocale.h>        //KDE
#include <kmenubar.h>       //KDE
#include <kpopupmenu.h>     //KDE
#include <kstatusbar.h>     //KDE
#include <kfiledialog.h>    //KDE
#include <kiconloader.h>    //KDE

#include <tag.h>            //TAGLIB
#include <tstring.h>        //TAGLIB
#include <tfile.h>          //TAGLIB
#include "ktrm.h"           //KDEADDON

#include <rightclickevent.h>//CURRENT PROJECT
#include <cdialogrenumber.h>//CURRENT PROJECT
#include <cdialogfileastag.h>//CURRENT PROJECT
#include <cdialogremoveprefix.h>//CURRENT PROJECT
#include <cdialogchoosefield.h>//CURRENT PROJECT
#include <ktagfileref.h>    //CURRENT PROJECT
#include "cdialogmusicbrainzfetch.h"  //CURRENT PROJECT

#include <qtable.h>         //QT
#include <qsplitter.h>      //QT
#include <qspinbox.h>       //QT
#include <qbuttongroup.h>   //QT
#include <qbutton.h>        //QT
#include <qlineedit.h>        //QT
#include <qcombobox.h>        //QT
#include <qdragobject.h>        //QT
#include <qvaluelist.h>        //QT
#include <qmemarray.h>        //QT
#include <qtooltip.h>       //QT
#include <qvaluevector.h>   //QT
#include "qcursor.h"    //QT
#include "qcheckbox.h"    //QT




class QTable;
class QStringList;
class KPopupMenu;




/**
 * @short Application Main Window
 * @author Mc <mc@bglug.it>
 * @version 0.1
 */

class Kmp3Tag : public KMainWindow
  {
    Q_OBJECT

  public:
    Kmp3Tag();
    virtual ~Kmp3Tag();
    void columnHideMenuShow(QPoint);
    QStringList     labels;


  private slots:
    /*$PUBLIC_SLOTS$*/
    void fileOpen();
    void fileOpenAdd();
    void tagChange(int row,int col);
    void columnSort(int labelId);
    void columnShowHideExec(int labelId);
    void rightClickMenuShow(int row,int col,int button,const QPoint &);
    void rightClick(int choose);
    void tagRenumber();
    void fileAsTag();
    void cellCopy();
    void cellPaste();
    void rowsRemove();
    void rowsRemovePrefix();
    void rowsRemoveAll();
    void musicbrainzFetchResult( KTRMResultList resultList , QString error);

  private:
    void	columnRefresh();
    void        columnLabelCreate();
    void        mainMenuBuilder();
    void        kTagFileRefToTable(int kTagId);
    void        cellClear();
    void        columnPopupMenuRefresh();
    int         columnLabelFinder(QString);
    int         columnLabelIdToColumnId(int labelId);
    void        fileOpenAddDragNDrop(QStringList files);
    void        musicbrainzFetchSubmit();
    QString     dialogChooseField();
    KTagFileRef* getKTagFileRefFromRowNum(int row);
    QValueList<KTagFileRef>::Iterator getKTagFileRefIteratorFromRowNum(int row);
    QMemArray<int> *selectedRows();

    QString         copyValue;
    QTable          *mainTable;
    KPopupMenu      *columnPopupMenu,
    *rightClickPopupMenu,
    *fileMenu,
    *help;
    KMenuBar        *menu;
    KStatusBar      *statusbar;
    int actualRowPos;
    int actualColPos;
    QValueList <KTagFileRef>  KTagFileRefList;
    KTRMLookup      *trm;



  protected:
    void dragEnterEvent(QDragEnterEvent *event);
    void dropEvent(QDropEvent *event);

  };


#endif // _KMP3TAG_H_


