/***************************************************************************
 *   Copyright (C) 2005 by Mc   *
 *   mc@bglug.it   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifndef KTAGFILEREF_H
#define KTAGFILEREF_H

#include <fileref.h>
#include <tag.h>
#include <tfile.h>
#include <kurl.h>
#include <qurl.h>
#include <qstring.h>
#include <qdir.h>
#include <qregexp.h>


class KTagFileRef
  {

  public:
    enum FIELDENUM
    {ALBUM,
     ARTIST,
     COMMENT,
     TITLE,
     GENRE,
     YEAR,
     TRACK,
     URL,
     ALL
    };

    KTagFileRef(){};
    KTagFileRef(const char * path , bool audioAnalysis , int TableId );
    virtual ~KTagFileRef();
    bool setField(FIELDENUM field, QString value);
    QString getField(FIELDENUM field);

    QString track;
    QString title;
    QString fileName;
    QString directory;
    QString url;
    QString album;
    QString artist;
    QString year;
    QString genre;
    QString comment;
    QUrl    qUrl;
    int     id;



  private:
    QRegExp spaceRegexp;
    bool audioAnalysis;
    void spacesRemover(QString &str);
    void infUpdate(int field);
    bool fileOpen( const char *filePath);

    TagLib::File *tagFile;
    TagLib::Tag  *tag;

  };

#endif
